SystemOrganization addCategory: #PromisePipelining!
SystemOrganization addCategory: #'PromisePipelining-Tests'!
SystemOrganization addCategory: #'PromisePipelining-Visualisation'!
SystemOrganization addCategory: #'PromisePipelining-Signals'!

Morph subclass: #PPArrow
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Visualisation'!

!PPArrow class methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:06'!
from: from to: to
	^ super new
		from: from;
		to: to;
		yourself! !

!PPArrow class methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:07'!
new
	^ self shouldNotImplement! !

!PPArrow methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:00'!
arrowBoundsAt: endPoint from: priorPoint 
	"Answer a triangle oriented along the line from priorPoint to endPoint."
	| d v angle wingBase arrowSpec length width |
	v := endPoint - priorPoint.
	angle := v degrees.
	d := 2.
	arrowSpec := self valueOfProperty: #arrowSpec ifAbsent: [5@4].
	length := arrowSpec x abs.  width := arrowSpec y abs.
	wingBase := endPoint + (Point r: d * length degrees: angle + 180.0).
	arrowSpec x >= 0
		ifTrue: [^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase + (Point r: d * width degrees: angle - 125.0) }]
		ifFalse: ["Negative length means concave base."
				^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase.
					wingBase + (Point r: d * width degrees: angle - 125.0) }]! !

!PPArrow methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:06'!
drawArrowOn: aCanvas
	aCanvas
		line: from to: to width: 2 color: Color black;
		drawPolygon: (self arrowBoundsAt: to from: from) fillStyle: Color black! !

!PPArrow methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:01'!
drawOn: aCanvas
	aCanvas
		translateBy: self owner position
		during: [ :canvas | self drawArrowOn: canvas ]! !

!PPArrow methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:05'!
from
	^ from! !

!PPArrow methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:05'!
from: aPoint
	from := aPoint! !

!PPArrow methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:06'!
to
	^ to! !

!PPArrow methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:06'!
to: aPoint
	to := aPoint! !

Morph subclass: #PPMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Visualisation'!

!PPMorph methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 16:23'!
model
	^ model! !

!PPMorph methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 16:24'!
model: anObject
	model := anObject! !

PPMorph subclass: #PPPromiseMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Visualisation'!

PPMorph subclass: #PPVisualizationMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Visualisation'!

!PPVisualizationMorph methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 18:02'!
doLayout
	! !

!PPVisualizationMorph methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 18:01'!
drawOn: aCanvas
	 ! !

!Object methodsFor: '*PromisePipelining' stamp: 'WS 1/11/2012 11:32'!
isPromise
	^ false! !

Object subclass: #PPPromisePipeliningVisualisation
	instanceVariableNames: 'window codeWidget executeButton listWidget canvasWidget resolveButton resolveText selectedPromise idToPromises promiseToMorphs nextPromiseId promisesToSignalIds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Visualisation'!

!PPPromisePipeliningVisualisation class methodsFor: 'as yet unclassified' stamp: 'WS 12/20/2011 21:56'!
open
	^ self new
		open;
		yourself! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
accept: aString
	^ false! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
buttonState
	^ true! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
codeText
	^ ''! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
defaultExtent
	^ 1200 @ 800! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:20'!
derive: subPromise from: parentPromise withMessage: aMessage
	! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
executeButtonText
	^ 'Execute'! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 18:03'!
executeCode
	| signalId |
	signalId := PPPromise onCreation: [ :promise | self promiseCreated: promise ].
	self initializePromises.
	listWidget updateList.
	codeWidget textMorph editor
		selectAll;
		evaluateSelection.
	PPPromise disconnectCreation: signalId.
	canvasWidget doLayout! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
initialize
	| scrollPane |
	super initialize.
	self initializePromises.
	
	codeWidget := PluggableTextMorphPlus on: self text: #codeText accept: #accept:.
	codeWidget styler: (SHTextStylerST80 new view: codeWidget; yourself).
	codeWidget wantsFrameAdornments: false.
	codeWidget textMorph editor model: self.
	
	executeButton := PluggableButtonMorphPlus on: self getState: #buttonState action: #executeCode label: #executeButtonText.
	
	listWidget := PluggableListMorph on: self list: #promises selected: #selectedPromise changeSelected: #selectedPromise:.
	
	scrollPane := ScrollPane new.
	canvasWidget := PPVisualizationMorph new
		model: self;
		yourself.
	scrollPane scroller addMorph: canvasWidget.
	
	resolveButton := PluggableButtonMorphPlus on: self getState: #buttonState action: #resolveSelectedPromise label: #resolveButtonText.
	resolveText := PluggableTextMorphPlus on: self text: #resolveText accept: #accept:.
	resolveText styler: (SHTextStylerST80 new view: resolveText; yourself).
	resolveText wantsFrameAdornments: false.
	resolveText textMorph editor model: self.
	
	window := SystemWindow new.
	window setWindowColor: window defaultColor.
	window setLabel: self labelString.
	window addMorph: codeWidget frame: (0 @ 0 corner: 0.7 @ 0.3).
	window addMorph: executeButton frame: (0.7 @ 0 corner: 1 @ 0.05).
	window addMorph: listWidget frame: (0.7 @ 0.05 corner: 1 @ 0.75).
	window addMorph: scrollPane frame: (0 @ 0.3 corner: 0.7 @ 1).
	window addMorph: resolveButton frame: (0.7 @ 0.75 corner: 1 @ 0.8).
	window addMorph: resolveText frame: (0.7 @ 0.8 corner: 1 @ 1).
	window model: self.! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:20'!
initializePromises
	selectedPromise := 0.
	idToPromises := Dictionary new.
	promisesToSignalIds ifNotNil: [
		promisesToSignalIds keysAndValuesDo: [ :promise :id | promise disconnect: id ].
	].
	promisesToSignalIds := Dictionary new.
	nextPromiseId := 1.
	canvasWidget ifNotNil: [ canvasWidget removeAllMorphs ].
	promiseToMorphs := Dictionary new! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
labelString
	^ 'Promise Pipelining Visualisation'! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:20'!
nextPromiseId
	| nextId |
	nextId := nextPromiseId.
	nextPromiseId := nextPromiseId + 1.
	^ nextId! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
open
	window openInWorldExtent: self defaultExtent! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 12:51'!
promiseCreated: promise
	| morph |
	idToPromises do: [ :oldPromise | oldPromise == promise ifTrue: [ ^ self ] ].
	idToPromises at: self nextPromiseId put: promise.
	promisesToSignalIds at: promise put: (promise onConnect: [ :parentPromise :subPromise :message | self derive: subPromise from: parentPromise withMessage: message ]).
	morph := PPPromiseMorph new
		model: promise;
		yourself.
	promiseToMorphs at: promise put: morph.
	canvasWidget addMorph: morph.
	promise whenResolved: [ self resolved: promise ].
	listWidget updateList.! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
promises
	| promises |
	promises := OrderedCollection new.
	idToPromises keysAndValuesDo: [ :id :promise |
		promises add: (id printString,': Promise ', (promise isResolved ifTrue: [ 'resolved with ',promise value ] ifFalse: [ 'not resolved' ]))
	].
	^ promises! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
resolveButtonText
	^ 'Resolve With'! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 18:09'!
resolveSelectedPromise
	self resolveSelectedPromiseWith: (resolveText textMorph editor evaluateSelection)! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
resolveSelectedPromiseWith: anObject
	| promise |
	promise := idToPromises at: selectedPromise ifAbsent: [ ^ false ].
	
	promise resolveWith: anObject.
	resolveText update: #resolveText.! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
resolveText
	^ ''! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
resolved: promise
	listWidget updateList! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
selectedPromise
	^ selectedPromise! !

!PPPromisePipeliningVisualisation methodsFor: 'as yet unclassified' stamp: 'WS 1/6/2012 17:19'!
selectedPromise: newIndex
	selectedPromise := newIndex.
	listWidget updateList! !

Object subclass: #PPSignal
	instanceVariableNames: 'callbacks nextId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Signals'!

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:45'!
connect: aBlock
	| id |
	id := nextId.
	callbacks at: id put: aBlock.
	nextId := nextId + 1.
	^ id
	! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:45'!
disconnect: anId
	^ callbacks removeKey: anId ifAbsent: []! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:40'!
disconnectAll
	^ callbacks removeAll! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:34'!
emit
	self emitWithArguments: #()! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1
	self emitWithArguments: (Array with: arg1)! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2
	self emitWithArguments: (Array with: arg1 with: arg2)! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2 with: arg3
	self emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:57'!
emitWithArguments: arguments
	callbacks do: [ :callback | 
		callback valueWithArguments: (self resizeArguments: arguments toFit: callback argumentCount)
	]! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:28'!
initialize
	super initialize.
	callbacks := Dictionary new.
	nextId := 0.! !

!PPSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:40'!
resizeArguments: arguments toFit: aSize
	| newArgs |
	newArgs := Array new: aSize.
	1 to: aSize do: [ :i |
		newArgs at: i put: (arguments at: i ifAbsent: [ nil ])
	].
	^ newArgs! !

Object subclass: #PPSignalHandler
	instanceVariableNames: 'signals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Signals'!

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'WS 1/4/2012 13:41'!
connect: signalName to: aBlock
	^ ( signals at: signalName ifAbsentPut: [ PPSignal new ])
		connect: aBlock! !

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:46'!
disconnect: signalName from: anId
	(signals at: signalName ifAbsent: [ ^ self ]) disconnect: anId! !

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emit! !

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1)! !

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2)! !

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2 with: arg3
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName withArguments: arguments
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emitWithArguments: arguments! !

!PPSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:36'!
initialize
	super initialize.
	signals := Dictionary new! !

TestCase subclass: #PPPromiseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining-Tests'!

!PPPromiseTest methodsFor: 'as yet unclassified' stamp: 'WS 12/14/2011 11:15'!
testDirectValue
	| promise result |
	promise := PPPromise new.
	result := Object new.
	
	self assert: [ promise directValue isNil ].
	
	promise resolveWith: result.
	
	self assert: [ promise directValue == result ].! !

!PPPromiseTest methodsFor: 'as yet unclassified' stamp: 'WS 12/14/2011 11:34'!
testPipelining
	| promise pipelinedPromise |
	promise := PPPromise new.
	pipelinedPromise := promise + 5.
	
	promise resolveWith: 5.
	self assert: [ pipelinedPromise value = 10 ].! !

!PPPromiseTest methodsFor: 'as yet unclassified' stamp: 'WS 1/5/2012 12:16'!
testResolvingThrowsNoException
	| promise resolveValue |
	promise := PPPromise new.
	resolveValue := 5.
	promise resolveWith: resolveValue.
	self assert: promise value = resolveValue.
	promise resolveWith: 2.
	self assert: promise value = resolveValue! !

!PPPromiseTest methodsFor: 'as yet unclassified' stamp: 'WS 12/14/2011 11:30'!
testValue
	| promise hasWaited result process innerComparison innerHasWaited |
	promise := PPPromise new.
	hasWaited := false.
	result := Object new.
	
	process := [
		innerComparison := promise value == result.
		innerHasWaited := hasWaited.
	] fork.
	hasWaited := true.
	
	promise resolveWith: result.
	
	[ process isTerminated ] whileFalse.

	self assert: innerComparison.
	self assert: innerHasWaited.! !

Promise subclass: #PPPromise
	instanceVariableNames: 'signal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PromisePipelining'!

PPPromise class
	instanceVariableNames: 'signal'!

PPPromise class
	instanceVariableNames: 'signal'!

!PPPromise class methodsFor: 'as yet unclassified' stamp: 'WS 1/5/2012 10:09'!
creationSignal
	^ signal ifNil: [ signal := PPSignal new ]! !

!PPPromise class methodsFor: 'as yet unclassified' stamp: 'WS 1/5/2012 10:11'!
disconnectCreation: id
	self creationSignal disconnect: id! !

!PPPromise class methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 12:50'!
new
	| promise |
	promise := super new.
	self creationSignal emitWith: promise.
	^ promise! !

!PPPromise class methodsFor: 'as yet unclassified' stamp: 'WS 1/5/2012 10:11'!
onCreation: aBlock
	^ self creationSignal connect: aBlock! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 12/13/2011 22:05'!
directValue
	^ super value! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:16'!
disconnect: anIndex
	^ signal disconnect: anIndex! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 12:36'!
doesNotUnderstand: aMessage
	| promise lastBlock |
	promise := PPPromise new.
	
	"lastBlock := [ | newArguments |
		newArguments := Array new: aMessage arguments size.
		aMessage arguments withIndexDo: [ :argument :index |
			newArguments at: index put: (argument isPromise ifTrue: [ argument wait ] ifFalse: [ argument ])
		].
		promise resolveWith: (self directValue perform: aMessage selector withArguments: newArguments)
	]."
	
	lastBlock := [ :arguments | promise resolveWith: (self directValue perform: aMessage selector withArguments: arguments) ].
	aMessage arguments withIndexDo: [ :argument :index |
		lastBlock := self prepareBlock: lastBlock forArgument: argument withIndex: index.
	].
	
	self whenResolved: [ lastBlock value: aMessage arguments ].
	signal emitWith: self with: promise with: aMessage.
	^ promise! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:10'!
initialize
	super initialize.
	signal := PPSignal new! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:32'!
isPromise
	^ true! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 11:12'!
onConnect: aBlock
	^ signal connect: aBlock! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 1/11/2012 12:36'!
prepareBlock: lastBlock forArgument: argument withIndex: index
	^ argument isPromise ifTrue: [
		[ :arguments |
			argument whenResolved: [ :value |
				arguments at: index put: value.
				lastBlock value: arguments
			]
		]
	] ifFalse: [
		lastBlock
	]! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 1/5/2012 12:14'!
resolveWith: arg
	"Resolve this promise"
	mutex critical: [
		isResolved ifTrue: [ ^ self ].
		value := arg.
		isResolved := true.
		resolvers ifNotNil: [resolvers do: [:r | self evaluateResolver: r]].
	]! !

!PPPromise methodsFor: 'as yet unclassified' stamp: 'WS 12/13/2011 22:03'!
value
	^ self wait! !
